local M = {}
M.type = "auxiliary"

local random = math.random

local particleType = 25
local particleInverval = 1e9
local particleAmount = 1
local spread = 0
local maxNodeId = 0

local timer = 0

local function update(dt)
    timer = timer + dt

    while timer >= particleInverval do
        local nodeId = random(0, maxNodeId)
        
        obj:addParticleByNodesRelative(nodeId, nodeId, 0, particleType, spread, particleAmount)
        
        timer = timer - particleInverval
    end
end

local function reset(jbeamData)
    timer = 0
end

local function init(jbeamData)
    particleType = jbeamData.particleType or 25
    particleInverval = 1 / guardZero(jbeamData.particlesPerSecond or 0)
    particleAmount = jbeamData.particleAmount or 0
    spread = jbeamData.spread or 0

    maxNodeId = tableSizeC(v.data.nodes) - 1
end

M.init = init
M.reset = reset
M.update = update

return M
